unit comp;

interface

uses
  Windows, Classes, CommCtrl, SysUtils, ComObj, ActiveX, TestLib_TLB, TestSnapin, mmc, ThreadedFactory, service;

const
  IDM_COMMAND1 = 0;
  IDM_COMMAND2 = 1;
  IDM_SAMPLE_OCX_VIEW = 2;
  IDM_SAMPLE_WEB_VIEW = 3;

  IsPrimaryImpl = TRUE;

  menuItems : array [0..2] of TContextMenuItem = (
    (strname : 'Command 1';
     strStatusBarText : 'Sample extension menu added by snapin (Command 1)';
     lCommandID : IDM_COMMAND1;
     lInsertionPointID : CCM_INSERTIONPOINTID_PRIMARY_TOP;
     fFlags : 0;
     fSpecialFlags : 0),

    (strname : 'Command 2';
     strStatusBarText : 'Sample extension menu added by snapin (Command 2)';
     lCommandID : IDM_COMMAND2;
     lInsertionPointID : CCM_INSERTIONPOINTID_PRIMARY_TOP;
     fFlags : 0;
     fSpecialFlags : 0),

    (strname : Nil;
     strStatusBarText : Nil;
     lCommandID : 0;
     lInsertionPointID : 0;
     fFlags : 0;
     fSpecialFlags : 0)
    );

  viewItems : array [0..2] of TContextMenuItem = (
    (strname : 'Calendar';
     strStatusBarText : 'Sample OCX custom view';
     lCommandID : IDM_SAMPLE_OCX_VIEW;
     lInsertionPointID : CCM_INSERTIONPOINTID_PRIMARY_VIEW;
     fFlags : 0;
     fSpecialFlags : 0),

    (strname : 'Microsoft';
     strStatusBarText : 'Sample WEB custom view';
     lCommandID : IDM_SAMPLE_WEB_VIEW;
     lInsertionPointID : CCM_INSERTIONPOINTID_PRIMARY_VIEW;
     fFlags : 0;
     fSpecialFlags : 0),

    (strname : Nil;
     strStatusBarText : Nil;
     lCommandID : 0;
     lInsertionPointID : 0;
     fFlags : 0;
     fSpecialFlags : 0)
    );


  SnapinButtons : array [0..8] of TMMCButton = (
    (nBitmap       : 0;
     idCommand     : 1;
     fsState       : TBSTATE_ENABLED;
     fsType        : TBSTYLE_BUTTON;
     lpButtonText  : 'Folder';
     lpTooltipText : 'New Folder'),
    (nBitmap       : 1;
     idCommand     : 2;
     fsState       : TBSTATE_ENABLED;
     fsType        : TBSTYLE_BUTTON;
     lpButtonText  : 'Inbox';
     lpTooltipText : 'Mail Inbox'),
    (nBitmap       : 2;
     idCommand     : 3;
     fsState       : TBSTATE_ENABLED;
     fsType        : TBSTYLE_BUTTON;
     lpButtonText  : 'Outbox';
     lpTooltipText : 'Mail Outbox'),
    (nBitmap       : 3;
     idCommand     : 4;
     fsState       : TBSTATE_ENABLED;
     fsType        : TBSTYLE_BUTTON;
     lpButtonText  : 'Send';
     lpTooltipText : 'Send Message'),
    (nBitmap       : 0;
     idCommand     : 0;
     fsState       : TBSTATE_ENABLED;
     fsType        : TBSTYLE_SEP;
     lpButtonText  : '';
     lpTooltipText : ''),
    (nBitmap       : 4;
     idCommand     : 5;
     fsState       : TBSTATE_ENABLED;
     fsType        : TBSTYLE_BUTTON;
     lpButtonText  : 'Trash';
     lpTooltipText : 'Trash'),
    (nBitmap       : 5;
     idCommand     : 6;
     fsState       : TBSTATE_ENABLED;
     fsType        : TBSTYLE_BUTTON;
     lpButtonText  : 'Open';
     lpTooltipText : 'Open Folder'),
    (nBitmap       : 6;
     idCommand     : 7;
     fsState       : TBSTATE_ENABLED;
     fsType        : TBSTYLE_BUTTON;
     lpButtonText  : 'News';
     lpTooltipText : 'Today''s News'),
    (nBitmap       : 7;
     idCommand     : 8;
     fsState       : TBSTATE_ENABLED;
     fsType        : TBSTYLE_BUTTON;
     lpButtonText  : 'INews';
     lpTooltipText : 'Internet News'));

  SnapinButtons2 : array [0..8] of TMMCButton = (
    (nBitmap       : 0;
     idCommand     : 10;
     fsState       : TBSTATE_ENABLED;
     fsType        : TBSTYLE_BUTTON;
     lpButtonText  : 'Compose';
     lpTooltipText : 'Compose Message'),
    (nBitmap       : 1;
     idCommand     : 20;
     fsState       : TBSTATE_ENABLED;
     fsType        : TBSTYLE_BUTTON;
     lpButtonText  : 'Print';
     lpTooltipText : 'Print Message'),
    (nBitmap       : 2;
     idCommand     : 30;
     fsState       : TBSTATE_ENABLED;
     fsType        : TBSTYLE_BUTTON;
     lpButtonText  : 'Find';
     lpTooltipText : 'Find Message'),
    (nBitmap       : 0;
     idCommand     : 0;
     fsState       : TBSTATE_ENABLED;
     fsType        : TBSTYLE_SEP;
     lpButtonText  : '';
     lpTooltipText : ''),
    (nBitmap       : 3;
     idCommand     : 40;
     fsState       : TBSTATE_ENABLED;
     fsType        : TBSTYLE_BUTTON;
     lpButtonText  : 'Inbox';
     lpTooltipText : 'Inbox'),
    (nBitmap       : 4;
     idCommand     : 50;
     fsState       : TBSTATE_ENABLED;
     fsType        : TBSTYLE_BUTTON;
     lpButtonText  : 'Smile';
     lpTooltipText : 'Smile :-)'),
    (nBitmap       : 5;
     idCommand     : 60;
     fsState       : TBSTATE_ENABLED;
     fsType        : TBSTYLE_BUTTON;
     lpButtonText  : 'Reply';
     lpTooltipText : 'Reply'),
    (nBitmap       : 0;
     idCommand     : 0;
     fsState       : TBSTATE_ENABLED;
     fsType        : TBSTYLE_SEP;
     lpButtonText  : '';
     lpTooltipText : ''),
    (nBitmap       : 6;
     idCommand     : 70;
     fsState       : TBSTATE_ENABLED;
     fsType        : TBSTYLE_BUTTON;
     lpButtonText  : 'Reply All';
     lpTooltipText : 'Reply All'));
type
  TCustomViewID = (
    VIEW_DEFAULT_LV,
    VIEW_CALENDAR_OCX,
    VIEW_MICROSOFT_URL
  );

  TIComponent = class(TInterfacedObject, IComponent, IExtendContextMenu, IExtendControlbar, IResultDataCompare, IResultOwnerData, IPersistStream)
  public
    fConsole : IConsole;
    m_CustomViewID : TCustomViewID;
    m_bVirtualView : boolean;
    m_bInitialized : boolean;
    m_dwVirtualSortOptions : DWORD;

    m_pResult : IResultData;
    m_pComponentData : pointer;
    m_pImageResult : IImageList;
    m_pHeader : IHeaderCtrl;
    m_pConsoleVerb : IConsoleVerb;
    m_pControlbar : IControlbar;
    m_pMenubutton1 : IMenuButton;
    m_pToolbar1 : IToolbar;
    m_pToolbar2 : IToolbar;
    m_bIsDirty : boolean;
    
    m_Column1 : WideString;
    m_Column2 : WideString;
    m_Column3 : WideString;

    constructor Create;

    function IComponent.Initialize = ComponentInitialize;
    function IComponent.Notify = ComponentNotify;
    function IComponent.Destroy = ComponentDestroy;
    function IComponent.QueryDataObject = ComponentQueryDataObject;
    function IComponent.GetResultViewType = ComponentGetResultViewType;
    function IComponent.GetDisplayInfo = ComponentGetDisplayInfo;
    function IComponent.CompareObjects = ComponentCompareObjects;

    function IExtendContextMenu.AddMenuItems = ExtendContextMenuAddMenuItems;
    function IExtendContextMenu.Command = ExtendContextMenuCommand;

    function IExtendControlbar.SetControlbar = ExtendControlbarSetControlbar;
    function IExtendControlbar.ControlbarNotify = ExtendControlbarControlbarNotify;

    function IResultDataCompare.Compare = ResultDataCompareCompare;

    function IResultOwnerData.FindItem = ResultOwnerDataFindItem;
    function IResultOwnerData.CacheHint = ResultOwnerDataCacheHint;
    function IResultOwnerData.SortItems = ResultOwnerDataSortItems;

    function IPersistStream.IsDirty = PersistStreamIsDirty;
    function IPersistStream.Load = PersistStreamLoad;
    function IPersistStream.Save = PersistStreamSave;
    function IPersistStream.GetSizeMax = PersistStreamGetSizeMax;
    function IPersistStream.GetClassID = PersistStreamGetClassID;

    // IComponent
    function ComponentInitialize(const lpConsole: IConsole): HResult; stdcall;
    function ComponentNotify (const dataObject : IDataObject; event : MMC_NOTIFY_TYPE; arg, param : LongInt) : HResult; stdcall;
    function ComponentDestroy (cookie : LongInt) : HResult; stdcall;
    function ComponentQueryDataObject (cookie : LongInt; types : DATA_OBJECT_TYPES; out dataObject : IDataObject) : HResult; stdcall;
    function ComponentGetResultViewType (cookie : LongInt; out viewType : PWideChar; out viewOptions : LongInt) : HResult; stdcall;
    function ComponentGetDisplayInfo (var resultDataItem : TResultDataItem) : HResult; stdcall;
    function ComponentCompareObjects (const dataObjectA, dataObjectB : IDataObject) : HResult; stdcall;

    // IExtendContextMenu
    function ExtendContextMenuAddMenuItems(const piDataObject: IDataObject; const piCallback: IContextMenuCallback; var pInsertionAllowed: Integer): HResult; stdcall;
    function ExtendContextMenuCommand (nCommandID: Integer; const dataObject: IDataObject): HResult; stdcall;

    // IExtendControlbar
    function ExtendControlbarSetControlbar(const pControlbar: IControlbar): HResult; stdcall;
    function ExtendControlbarControlbarNotify(event: MMC_NOTIFY_TYPE; arg, param: Integer): HResult; stdcall;

    // IResultDataCompare
    function ResultDataCompareCompare(lUserParam, cookieA, cookieB: Integer; var pnResult: SYSINT): HResult; stdcall;

    // IResultOwnerData
    function ResultOwnerDataFindItem(var pFindInfo: TResultFindInfo; out pnFoundIndex: SYSINT): HResult; stdcall;
    function ResultOwnerDataCacheHint(nStartIndex, nEndIndex: SYSINT): HResult; stdcall;
    function ResultOwnerDataSortItems(nColumn: SYSINT; dwSortOptions: UINT; lUserParam: Integer): HResult; stdcall;

    // IPersistStream
    function PersistStreamIsDirty: HResult; stdcall;
    function PersistStreamLoad (const stm: IStream): HResult; stdcall;
    function PersistStreamSave (const stm: IStream; fClearDirty: BOOL): HResult; stdcall;
    function PersistStreamGetSizeMax (out cbSize: Largeint): HResult; stdcall;
    function PersistStreamGetClassID (out classID: TCLSID): HResult; stdcall;


    procedure SetIComponentData (const data : TTTestSnapin);
    function GetVirtualResultItem (index : Integer) : PResultData;

    function OnRefresh (dataObject : IDataObject) : HRESULT;
    function OnPropertyChange (dataObject : IDataObject) : HRESULT;
    function OnUpdateView (dataObject : IDataObject) : HRESULT;
    function OnResultItemClick (tp, cookie : Integer) : HRESULT;

    function OnAddImages(cookie, arg, param : LongInt) : HRESULT;
    function OnShow (cookie, arg, param : LongInt) : HRESULT;
    function OnMinimize (cookie, arg, param : LongInt) : HRESULT;
    function OnContextHelp (dataObject : IDataObject) : HRESULT;
    procedure OnButtonClick (dataObject : IDataObject; idBtn : Integer);

    function InitializeBitmaps (cookie : LongInt) : HRESULT;
    function InitializeHeaders (cookie : LongInt) : HRESULT;
    procedure EnumerateResultPane (cookie : LongInt);
    procedure HandleStandardVerbs (bDeselectAll : boolean; arg : LongInt; dataObject : IDataObject);
    procedure GetItemName (dataObject : IDataObject; name : PWideChar);
    function HandleExtToolbars(bDeselectAll : boolean; arg, param : LongInt) : HRESULT;
    procedure HandleExtMenus (arg, param : LongInt);
    function QueryMultiSelectDataObject (cookie : LongInt;  tp : DATA_OBJECT_TYPES; var dataObject : IDataObject) : HRESULT;
  end;

function IsMMCMultiSelectDataObject (dataObject : IDataObject) : BOOL;

implementation

uses ComServ, DataObject;
// We use a single structure for all virtual items, so
// the name field points to this buffer that is changed
// on the fly.
var
  VirtualItemName : array [0..MAX_ITEM_NAME - 1] of WideChar;

const
  StaticRootData : array [0..NUM_NAMES - 1] of TResultData = (
    (parentType : ftUser; szName : 'Bill'; szSize : '990'; szType : 'CEO'),
    (parentType : ftUser; szName : 'Jill'; szSize : '991'; szType : 'Director'),
    (parentType : ftUser; szName : 'Hill'; szSize : '992'; szType : 'President'),
    (parentType : ftUser; szName : 'Will'; szSize : '993'; szType : 'Chairman')
  );

  UserData : array [0..NUM_NAMES - 1] of TResultData = (
    (parentType : ftUser; szName : 'Joe'; szSize : '100'; szType : 'Employee'),
    (parentType : ftUser; szName : 'Harry'; szSize : '101'; szType : 'Manager'),
    (parentType : ftUser; szName : 'Jane'; szSize : '102'; szType : 'Vice President'),
    (parentType : ftUser; szName : 'Sue'; szSize : '103'; szType : 'Developer')
  );

  CompanyData : array [0..NUM_COMPANY - 1] of TResultData = (
    (parentType : ftCompany; szName : 'Taxes'; szSize : '43'; szType : 'IRS Documents'),
    (parentType : ftCompany; szName : 'Medical'; szSize : '345'; szType : 'HMO'),
    (parentType : ftCompany; szName : 'Dental'; szSize : '121'; szType : 'Plus Plan'),
    (parentType : ftCompany; szName : 'Insurance'; szSize : '2332'; szType : 'Dollars are Us'),
    (parentType : ftCompany; szName : '401K'; szSize : '1000'; szType : 'Up to you'),
    (parentType : ftCompany; szName : 'Legal'; szSize : '78'; szType : 'Yes')
  );

  UserDataExt : array [0..NUM_NAMES - 1] of TResultData = (
    (parentType : ftExt_User; szName : 'Charles'; szSize : '200'; szType : 'Employee'),
    (parentType : ftExt_User; szName : 'Jill'; szSize : '201'; szType : 'Manager'),
    (parentType : ftExt_User; szName : 'John'; szSize : '202'; szType : 'Vice President'),
    (parentType : ftExt_User; szName : 'Tami'; szSize : '203'; szType : 'Developer')
  );

  CompanyDataExt : array [0..NUM_COMPANY - 1] of TResultData = (
    (parentType : ftExt_Company; szName : 'Payroll'; szSize : '43'; szType : 'Corporate Payroll'),
    (parentType : ftExt_Company; szName : 'Health'; szSize : '345'; szType : 'HMO'),
    (parentType : ftExt_Company; szName : 'Health Club'; szSize : '121'; szType : 'Plus Plan'),
    (parentType : ftExt_Company; szName : 'Insurance'; szSize : '2332'; szType : 'Dollars are Us'),
    (parentType : ftExt_Company; szName : '401K'; szSize : '1000'; szType : 'Up to you'),
    (parentType : ftExt_Company; szName : 'Legal'; szSize : '78'; szType : 'Yes')
  );

  VirtualData : array [0..0] of TResultData = (
    (ParentType:ftVirtual; szName:VirtualItemName; szSize:'100'; szType:'Virtual')
  );

function IsMMCMultiSelectDataObject (dataObject : IDataObject) : BOOL;
const
  s_cf : Integer = 0;

var
  fmt : TFormatETC;
begin
  if not Assigned (dataObject) then
    result := False
  else
  begin
    if s_cf = 0 then
      s_cf := RegisterClipboardFormat (CCF_MMC_MULTISELECT_DATAOBJECT);

    fmt.cfFormat := s_cf;
    fmt.ptd := Nil;
    fmt.dwAspect := DVASPECT_CONTENT;
    fmt.lindex := -1;
    fmt.tymed := TYMED_HGLOBAL;

    result := dataObject.QueryGetData (fmt) = S_OK
  end
end;

constructor TIComponent.Create;
begin
  m_CustomViewID := VIEW_DEFAULT_LV;
  m_bIsDirty := True;
end;

procedure TIComponent.SetIComponentData (const data : TTTestSnapin);
begin
  m_pComponentData := data;
end;

function TIComponent.ComponentInitialize (const lpConsole : IConsole) : HResult;
begin
  Assert (Assigned (lpConsole));
  m_bInitialized := true;

  fConsole := lpConsole;

  m_Column1 := 'Name';
  m_Column2 := 'Size';
  m_Column3 := 'Type';
  
  if fConsole.QueryInterface (StringToGuid (IID_IHeaderCtrl), m_pHeader) = S_OK then
    fConsole.SetHeader (m_pHeader);

  fConsole.QueryInterface(StringToGuid (IID_IResultData), m_pResult);

  OleCheck (fConsole.QueryResultImageList(m_pImageResult));
  OleCheck (fConsole.QueryConsoleVerb (m_pConsoleVerb));

  result := S_OK;
end;

function TIComponent.ComponentNotify (const dataObject : IDataObject; event : MMC_NOTIFY_TYPE; arg, param : LongInt) : HResult;
var
  cookie : LongInt;
  internal : PInternal;
begin
  result := S_OK;
  if IS_SPECIAL_DATAOBJECT (dataObject) then
  begin
    if event = MMCN_BTN_CLICK then
    begin
      if m_CustomViewID <> VIEW_DEFAULT_LV then
      case param of
        MMC_VERB_REFRESH :
          begin
            MessageBox (0, 'MMCN_BTN_CLICK::MMC_VERB_REFRESH', '', MB_ICONINFORMATION);
            OnRefresh (dataObject);
          end;

        MMC_VERB_PROPERTIES :
            MessageBox (0, 'MMCN_BTN_CLICK::MMC_VERB_PROPERTIES', '', MB_ICONINFORMATION);

        else
            MessageBox (0, 'MMCN_BTN_CLICK::param unknown', '', MB_ICONINFORMATION)
      end
    end
    else
      case event of
        MMCN_REFRESH:
          begin
            MessageBox (0, 'MMCN_BTN_CLICK::MMC_VERB_REFRESH', '', MB_ICONINFORMATION);
            OnRefresh (dataObject)
          end
      end
  end
  else
  case event of
    MMCN_PROPERTY_CHANGE : result := OnPropertyChange(dataObject);
    MMCN_VIEW_CHANGE     : result := OnUpdateView (dataObject);
    MMCN_DESELECT_ALL    : ;
    MMCN_COLUMN_CLICK    : ;
    MMCN_SNAPINHELP      : ;
    else
      begin
        internal := Nil;
        cookie := 0;

        if not IsMMCMultiSelectDataObject(dataObject) then
        begin
          internal := ExtractInternalFormat (dataObject);
          if not Assigned (internal) then
          begin
            Assert (False);
            exit
          end;

          cookie := internal^.m_cookie
        end;

        case event of
          MMCN_ACTIVATE     : ;
          MMCN_CLICK        : OnResultItemClick (internal^.m_type, cookie);
          MMCN_DBLCLICK     :
            if internal^.m_type = CCT_RESULT then
              ExtendContextMenuCommand (IDM_COMMAND1, dataObject)
            else
              result := S_FALSE;

          MMCN_ADD_IMAGES   : OnAddImages (cookie, arg, param);
          MMCN_SHOW         :
            result := OnShow(cookie, arg, param);
          MMCN_MINIMIZED    : result := OnMinimize(cookie, arg, param);
          MMCN_INITOCX      :
            begin
              MessageBox (0, 'MMCN_INITOCX', 'TRACE', MB_ICONINFORMATION);
              Assert (param <> 0)
            end;

          MMCN_DESELECT_ALL,
          MMCN_SELECT       : HandleStandardVerbs(event = MMCN_DESELECT_ALL, arg, DataObject);
          MMCN_PASTE        : MessageBox (0, 'MMCN_PASTE', 'TRACE', MB_ICONINFORMATION);
          MMCN_DELETE       : MessageBox (0, 'MMCN_DELETE', 'TRACE', MB_ICONINFORMATION);
          MMCN_CONTEXTHELP  : result := OnContextHelp (dataObject);
          MMCN_REFRESH      :
            begin
              MessageBox (0, 'MMCN_REFRESH', '', MB_ICONINFORMATION);
              OnRefresh (dataObject)
            end;

          MMCN_RENAME       : MessageBox (0, 'MMCN_RENAME', 'TRACE', MB_ICONINFORMATION);
          else
           result := E_UNEXPECTED
        end;

        if Assigned (Internal) then
          GlobalFree (THandle (internal));
      end
  end;

  if Assigned (m_pResult) then
     m_pResult.SetDescBarText('hello world');
end;

function TIComponent.ComponentDestroy (cookie : LongInt) : HResult;
begin
  if fConsole <> Nil then
  begin
    fConsole := Nil;
  end;
  result := S_OK;
end;

function TIComponent.QueryMultiSelectDataObject (cookie : LongInt;  tp : DATA_OBJECT_TYPES; var dataObject : IDataObject) : HRESULT;
var
  rgGuids : TMemoryStream;
  rdi : TResultDataItem;
  fType : FOLDER_TYPES;
  folder : TFolder;
  guid : PGuid;
  pObject : TDataObject;
  count, cb : Integer;
  data : pByte;
begin
  rgGuids := TMemoryStream.Create;
  count := 0;
  result := S_OK;
  try
    if m_bVirtualView then
    begin
      rgGuids.WriteBuffer (cNodeTypeCompany, sizeof (TGuid));
      Inc (count);
    end
    else
    begin
      Assert (Assigned (m_pResult));
      FillChar (rdi, sizeof (rdi), 0);
      rdi.mask := RDI_STATE;
      rdi.nIndex := -1;
      rdi.nState := TVIS_SELECTED;

      while m_pResult.GetNextItem (rdi) = S_OK do
      begin
        if rdi.bScopeItem then
          fType := TFolder (rdi.lParam).FolderType
        else
          fType := PResultData (rdi.lParam)^.parentType;

        case fType of
          ftStatic     : guid := @cNodeTypeStatic;
          ftCompany    : guid := @cNodeTypeCompany;
          ftUser       : guid := @cNodeTypeUser;
          ftExt_Company : guid := @cNodeTypeExtCompany;
          ftExt_User    : guid := @cNodeTypeExtUser;
          ftVirtual,
          ftExt_Virtual : guid := @cNodeTypeVirtual;
          else
            result := E_FAIL;
        end;

        if result = S_OK then
        begin
          rgGuids.WriteBuffer (guid^, sizeof (TGuid));
          Inc (count)
        end
        else
          break;
      end
    end;

    if result = S_OK then
    begin
      pObject := TDataObject.Create;
      pObject.ObjectType := tp;
      pObject.Cookie := cookie;
      pObject.SetMultiSelDobj;
      pObject.CLSID := TTTestSnapin (m_pComponentData).GetCoClassID ();

      cb := count * sizeof (TGuid);
      GetMem (data, cb);
      Move (rgGuids.Memory^, data^, cb);
      pObject.SetMultiSelData (data, cb);

      dataObject := pObject as IDataObject
    end
  finally
    rgGuids.Free
  end
end;

function TIComponent.ComponentQueryDataObject (cookie : LongInt; types : DATA_OBJECT_TYPES; out dataObject : IDataObject) : HResult;
begin
  if cookie = MMC_MULTI_SELECT_COOKIE then
    result := QueryMultiSelectDataObject (cookie, types, dataObject)
  else
  begin
    Assert (types = CCT_RESULT);

    Assert (Assigned (m_pComponentData));
    _QueryDataObject (cookie, types, TTTestSnapin (m_pComponentData), dataObject);
    result := S_OK
  end
end;

function TIComponent.ComponentGetResultViewType (cookie : LongInt; out viewType : PWideChar; out viewOptions : LongInt) : HResult;
const
  szCalendarGUID = '{8E27C92B-1264-101C-8A2F-040224009C02}';
  szMicrosoftURL = 'www.microsoft.com';
var
  pFolder : TFolder;
  ftype : FOLDER_TYPES;

begin
  result := S_FALSE;
  viewOptions := MMC_VIEW_OPTIONS_MULTISELECT;

  // if list view
  if m_CustomViewID = VIEW_DEFAULT_LV then
  begin
    m_bVirtualView := FALSE;

  // if static folder not selected
    if cookie <> 0 then
    begin
      pFolder := TFolder (cookie);
      ftype := pFolder.FolderType;
      m_bVirtualView := (ftype = ftVirtual) or (ftype = ftExt_Virtual);

      if m_bVirtualView then
        viewOptions := viewOptions or MMC_VIEW_OPTIONS_OWNERDATALIST
    end
  end
  else
  begin
    if m_CustomViewID = VIEW_CALENDAR_OCX then
      ViewType := StringToLPOleStr (szCalendarGUID)
    else
      ViewType := StringToLPOleStr (szMicrosoftURL);

    if Assigned (ViewType) then
      result := S_OK
  end
end;

function StringFromFolderType (tp : FOLDER_TYPES) : PWideChar;
begin
  case tp of
    ftStatic  : result := 'Static';
    ftCompany : result := 'Company';
    ftUser    : result := 'User';
    ftVirtual : result := 'Virtual';
    else result := 'Unknown'
  end
end;

function TIComponent.GetVirtualResultItem (index : Integer) : PResultData;
begin
  if (m_dwVirtualSortOptions and RSI_DESCENDING) <> 0 then
    index := (NUM_VIRTUAL_ITEMS - 1) - index;

  StringtoWideChar (IntToStr (index), VirtualItemName, sizeof (VirtualItemName));
  result := @VirtualData [0];
end;

function TIComponent.ComponentGetDisplayInfo (var resultDataItem : TResultDataItem) : HResult;
const
  s_szSize : PWideChar = '200';
var
  folder : TFolder;
  pData : PResultData;
begin
  if resultDataItem.bScopeItem then
  begin
    folder := TFolder (resultDataItem.lParam);
    if (resultDataItem.mask and RDI_STR) <> 0 then
    begin
      if resultDataItem.nCol = 0 then
        resultDataItem.str := folder.FolderName
      else
        if resultDataItem.nCol = 1 then
          resultDataItem.str := s_szSize
        else
          resultDataItem.str := StringFromFolderType (folder.FolderType);
      Assert (Assigned (resultDataItem.str))
    end
  end
  else
  begin
    if m_bVirtualView then
      pData := GetVirtualResultItem (resultDataItem.nIndex)
    else
      pData := PResultData (resultDataItem.lParam);

    if (resultDataItem.mask and RDI_STR) <> 0 then
    begin
      if resultDataItem.nCol = 0 then
        resultDataItem.str := pData^.szName
      else
        if resultDataItem.nCol = 1 then
          resultDataItem.str := pData^.szSize
        else
          resultDataItem.str := pData^.szType
    end;

    if (resultDataItem.mask and RDI_IMAGE) <> 0 then
      resultDataItem.nImage := 4
  end;

  result := S_OK
end;

function TIComponent.ComponentCompareObjects (const dataObjectA, dataObjectB : IDataObject) : HResult;
begin
  result := S_FALSE;
end;

function TIComponent.OnRefresh (dataObject : IDataObject) : HRESULT;
var
  internal : PInternal;
  folder : TFolder;
  sName : string;
begin
  result := S_OK;
  internal := ExtractInternalFormat(dataObject);
  if Assigned (internal) then
  try
    if internal.m_type = CCT_SCOPE then
    begin
      folder := TTTestSnapin (m_pComponentData).FindObject (internal^.m_cookie);
      if internal^.m_cookie <> 0 then
      begin
        sName := folder.FolderName;
        MessageBox (0, PChar (sName), '', MB_ICONINFORMATION)
      end
      else
        MessageBox (0, 'Files', '', MB_ICONINFORMATION);
    end
    else
    begin
      sName := PResultData (internal.m_cookie)^.szName;
      MessageBox (0, PChar (sName), '', MB_ICONINFORMATION)
    end;
  finally
    GlobalFree (THandle (internal));
  end
  else
    result := S_FALSE;
end;

function TIComponent.OnPropertyChange (dataObject : IDataObject) : HRESULT;
begin
  result := S_OK;
end;

function TIComponent.OnUpdateView (dataObject : IDataObject) : HRESULT;
begin
  result := S_OK;
end;

function TIComponent.OnResultItemClick (tp, cookie : Integer) : HRESULT;
var
  resultData : PResultData;
begin
  if m_bVirtualView then
    resultData := GetVirtualResultItem (cookie)
  else
    if cookie <> 0 then
      resultData := PResultData (cookie);

  result := S_OK;
end;

function TIComponent.ExtendContextMenuCommand(nCommandID: Integer; const dataObject: IDataObject): HResult; stdcall;

var
  internal : PInternal;
  componentData : TTTestSnapin;
  folder : TFolder;
  rdi : TResultDataItem;
  iSel : Integer;
  pData : PResultData;
  strBuf : string;
begin
  result := S_OK;
  internal := ExtractInternalFormat(dataObject);

  if Assigned (internal) then
  try
    if internal^.m_type = CCT_SCOPE then
    case nCommandID of
      IDM_SAMPLE_WEB_VIEW,
      IDM_SAMPLE_OCX_VIEW :
        begin
          if nCommandID = IDM_SAMPLE_OCX_VIEW then
            m_CustomViewID := VIEW_CALENDAR_OCX
          else
            m_CustomViewID := VIEW_MICROSOFT_URL;

          if internal^.m_cookie = 0 then
          begin
            componentData := TTTestSnapin (m_pComponentData);
            Assert (Assigned (componentData));
            fConsole.SelectScopeItem (componentData.fStaticRoot)
          end
          else
          begin
            folder := TFolder (internal.m_cookie);
            fConsole.SelectScopeItem (folder.ScopeItem^.ID)
          end
        end;

      MMCC_STANDARD_VIEW_SELECT: m_CustomViewID := VIEW_DEFAULT_LV;
      else
        result := TTTestSnapin (m_pComponentData).ExtendContextMenuCommand (nCommandID, dataObject);
    end
    else
      if internal.m_type = CCT_RESULT then
      case nCommandID of
        IDM_COMMAND1,
        IDM_COMMAND2:
          begin
            m_pResult.ModifyViewStyle (MMC_SINGLESEL, 0);
            FillChar (rdi, Sizeof (rdi), 0);
            rdi.mask := RDI_STATE;
            rdi.nState := LVIS_SELECTED;
            rdi.nIndex := -1;
            m_pResult.GetNextItem (rdi);
            iSel := rdi.nIndex;

            if m_bVirtualView then
              pData := GetVirtualResultItem (iSel)
            else
            begin
              FillChar (rdi, sizeof (rdi), 0);
              rdi.mask := RDI_PARAM;
              rdi.nIndex := iSel;
              OleCheck (m_pResult.GetItem (rdi));
              Assert (rdi.lParam <> 0);
              pData := PResultData (rdi.lParam)
            end;

            if nCommandID = IDM_COMMAND1 then
              strBuf := 'Command 1 executed.'#10#10
            else
              strBuf := 'Command 1 executed'#10#10;

            strBuf := strBuf + pData^.szName;
            strBuf := strBuf + ' is the currently selected item.';

            MessageBox (0, PChar (strBuf), '', MB_ICONINFORMATION);

            // change image in list
            if not m_bVirtualView then
            begin
              FillChar (rdi, SizeOf (rdi), 0);
              rdi.mask := RDI_IMAGE;
              rdi.nIndex := 3;
              rdi.nImage := 3;
              OleCheck (m_pResult.SetItem (rdi))
            end
          end;

        else
          Assert (False); // Unknown command!
      end
      else
        Assert (FALSE);

  finally
    GlobalFree (THandle (internal))
  end
  else
    result := E_FAIL;
end;

function TIComponent.ExtendContextMenuAddMenuItems(const piDataObject: IDataObject; const piCallback: IContextMenuCallback; var pInsertionAllowed: Integer): HResult;
var
  componentData : TTTestSnapin;
begin
  if m_CustomViewID = VIEW_CALENDAR_OCX then
    viewItems [0].fFlags := MF_CHECKED
  else
    viewItems [0].fFlags := 0;

  if m_CustomViewID = VIEW_MICROSOFT_URL then
    viewItems [1].fFlags := MF_CHECKED
  else
    viewItems [1].fFlags := 0;

  componentData := TTTestSnapin (m_pComponentData);

  result := componentData.ExtendContextMenuAddMenuItems (pidataObject, piCallback, pInsertionAllowed);
end;

function TIComponent.InitializeBitmaps (cookie : LongInt) : HRESULT;
var
  bmp16x16, bmp32x32 : HBITMAP;
begin
  Assert (Assigned (m_pImageResult));

  bmp16x16 := LoadBitmap (hInstance, 'BMP16x16');
  bmp32x32 := LoadBitmap (hInstance, 'BMP32x32');
  try
    m_pImageResult.ImageListSetStrip(bmp16x16, bmp32x32, 0, RGB(255, 0, 255));
    // OleCheck (m_pImageResult.ImageListSetStrip(bmp16x16, bmp32x32, 0, RGB(255, 0, 255)));
  finally
    DeleteObject (bmp16x16);
    DeleteObject (bmp32x32)
  end;

  result := S_OK;
end;

function TIComponent.InitializeHeaders (cookie : LongInt) : HRESULT;
begin
  result := S_OK;
  Assert (Assigned (m_pHeader));

    // Put the correct headers depending on the cookie
    // Note - cookie ignored for this sample
  m_pHeader.InsertColumn (0, PWideChar (m_Column1), LVCFMT_LEFT, 180);     // Name
  m_pHeader.InsertColumn (1, PWideChar (m_Column2), LVCFMT_RIGHT, 90);     // Size
  m_pHeader.InsertColumn (2, PWideChar (m_Column3), LVCFMT_LEFT, 160);     // Type
end;

procedure TIComponent.EnumerateResultPane (cookie : LongInt);
var
  folder : TFolder;
  tp : FOLDER_TYPES;

  procedure AddResultItems (pData : PResultData; count, imageIndex : Integer);
  var
    resultItem : TResultDataItem;
    i : Integer;
  begin
    FillChar (resultItem, sizeof (resultItem), 0);
    for i := 0 to count - 1 do
    begin
      resultItem.mask := RDI_STR or RDI_IMAGE or RDI_PARAM;
      resultItem.str  := MMC_CALLBACK;
      resultItem.nImage := imageIndex;
      resultItem.lParam := LongInt (pData);
      Inc (pData);
      m_pResult.InsertItem (resultItem);
    end;

    m_pResult.Sort (0, 0, -1);
  end;

  procedure AddUSer;
  begin
    AddResultItems (@UserData[0], NUM_NAMES, 4);
  end;

  procedure AddCompany;
  begin
    AddResultItems (@CompanyData[0], NUM_COMPANY, 3);
  end;

  procedure AddExtUser;
  begin
    AddResultItems(@UserDataExt[0], NUM_NAMES, 4);
  end;

  procedure AddExtCompany;
  begin
    AddResultItems (@CompanyDataExt[0], NUM_COMPANY, 3);
  end;

  procedure AddVirtual;
  begin
    // for virtual data, just set the item count
    m_pResult.SetItemCount (NUM_VIRTUAL_ITEMS, MMCLV_UPDATE_NOINVALIDATEALL);
  end;

begin
  Assert (Assigned (m_pResult));
  Assert (Assigned (m_pComponentData));
  folder := TTTestSnapin (m_pComponentData).FindObject (cookie);
  Assert (Assigned (folder));
  tp := Folder.FolderType;

  case tp of
    ftStatic     : AddResultItems (@StaticRootData [0], NUM_NAMES, 4);
    ftCompany    : AddCompany;
    ftUser       : AddUser;
    ftExt_User   : AddExtUser;
    ftExt_Company: AddExtCompany;
    ftVirtual,
    ftExt_Virtual: AddVirtual;
  end
end;


function TIComponent.OnAddImages(cookie, arg, param : LongInt) : HRESULT;
begin
  if arg = 0 then
    result := E_INVALIDARG
  else
  begin
    result := S_OK;
    InitializeBitmaps (cookie);
  end
end;

function TIComponent.OnShow (cookie, arg, param : LongInt) : HRESULT;
begin
  if arg = 1 then
  begin
        // if list view on display
    if m_CustomViewID = VIEW_DEFAULT_LV then
    begin
      InitializeHeaders(cookie);
      EnumerateResultPane (cookie)
    end;
        
        // BUBBUG - Demonstration to should how you can attach
        // and a toolbar when a particular nodes gets focus.
        // warning this needs to be here as the toolbars are
        // currently hidden when the previous node looses focus.
        // This should be update to show the user how to hide
        // and show toolbars. (Detach and Attach).

        //m_pControlbar->Attach(TOOLBAR, (LPUNKNOWN) m_pToolbar1);
        //m_pControlbar->Attach(TOOLBAR, (LPUNKNOWN) m_pToolbar2);
  end
  else
  begin

        // BUGBUG - Demonstration this to show how to hide toolbars that
        // could be particular to a single node.
        // currently this is used to hide the toolbars the console
        // does not do any toolbar clean up.

        //m_pControlbar->Detach(m_pToolbar1);
        //m_pControlbar->Detach(m_pToolbar2);
        // Free data associated with the result pane items, because
        // your node is no longer being displayed.
        // Note: The console will remove the items from the result pane
  end;

  result := S_OK
end;

function TIComponent.OnMinimize (cookie, arg, param : LongInt) : HRESULT;
begin
  result := S_OK;
end;

function TIComponent.OnContextHelp (dataObject : IDataObject) : HRESULT;
var
  name : array [0..128] of WideChar;
  msg : string;
begin
  GetItemName (dataObject, name);
  msg := Format ('Context help required for item: %s', [name]);
  MessageBox (0, PChar (msg), '', MB_ICONINFORMATION);
  result := S_OK;
end;

procedure TIComponent.OnButtonClick (dataObject : IDataObject; idBtn : Integer);
var
  name : array [0..128] of WideChar;
  msg : string;
begin
  GetItemName (dataObject, name);
  msg := Format ('Toolbar button <%d> was clicked, '#10'The currently selected result item is <%s>', [idBtn, name]);
  MessageBox (0, PChar (msg), '', MB_ICONINFORMATION);
end;

procedure TIComponent.HandleStandardVerbs (bDeselectAll : boolean; arg : LongInt; dataObject : IDataObject);
var
  bScope, bSelect : WORDBOOL;
  internal : PInternal;
begin
  if m_CustomViewID <> VIEW_DEFAULT_LV then
  begin
    m_pConsoleVerb.SetVerbState (MMC_VERB_REFRESH, HIDDEN, FALSE);
    m_pConsoleVerb.SetVerbState(MMC_VERB_REFRESH, ENABLED, TRUE);

    m_pConsoleVerb.SetVerbState(MMC_VERB_PROPERTIES, HIDDEN, FALSE);
    m_pConsoleVerb.SetVerbState(MMC_VERB_PROPERTIES, ENABLED, TRUE)
  end
  else
    if bDeselectAll or Assigned (dataObject) then
    begin
    // You should crack the data object and enable/disable/hide standard
    // commands appropriately.  The standard commands are reset everytime you get
    // called. So you must reset them back.

      bScope := WORDBOOL (LOWORD (arg));
      bSelect := WORDBOOL (HIWORD (arg));

      if not bDeselectAll and IsMMCMultiSelectDataObject(dataObject) then
      begin
        m_pConsoleVerb.SetVerbState (MMC_VERB_DELETE, HIDDEN, FALSE);
        m_pConsoleVerb.SetVerbState (MMC_VERB_DELETE, ENABLED, TRUE)
      end
      else
      begin
        if Assigned (dataObject) then
          internal := ExtractInternalFormat (dataObject)
        else
          internal := Nil;

        try
          if bDeselectAll or not bSelect then
          begin
            if bScope then
            begin
              m_pConsoleVerb.SetVerbState(MMC_VERB_OPEN, ENABLED, FALSE);
              m_pConsoleVerb.SetVerbState(MMC_VERB_COPY, ENABLED, FALSE);
              m_pConsoleVerb.SetVerbState(MMC_VERB_PASTE, ENABLED, FALSE);
              m_pConsoleVerb.SetVerbState(MMC_VERB_DELETE, ENABLED, FALSE);
              m_pConsoleVerb.SetVerbState(MMC_VERB_PROPERTIES, ENABLED, FALSE);
              m_pConsoleVerb.SetVerbState(MMC_VERB_RENAME, ENABLED, FALSE);

              m_pConsoleVerb.SetVerbState(MMC_VERB_REFRESH, HIDDEN, FALSE);
              m_pConsoleVerb.SetVerbState(MMC_VERB_REFRESH, ENABLED, TRUE)
            end
            else
            begin
              // Result pane background
              m_pConsoleVerb.SetVerbState(MMC_VERB_PASTE, HIDDEN, FALSE);
              m_pConsoleVerb.SetVerbState(MMC_VERB_PASTE, ENABLED, TRUE);

              if Assigned (internal) and (internal^.m_Cookie = 0) then
              begin
                m_pConsoleVerb.SetVerbState(MMC_VERB_PROPERTIES, HIDDEN, FALSE);
                m_pConsoleVerb.SetVerbState(MMC_VERB_PROPERTIES, ENABLED, TRUE)
              end;

              m_pConsoleVerb.SetVerbState(MMC_VERB_REFRESH, HIDDEN, FALSE);
              m_pConsoleVerb.SetVerbState(MMC_VERB_REFRESH, ENABLED, TRUE)
            end
          end
          else
            if Assigned (m_pConsoleVerb) and Assigned (internal) then
            begin
              if internal^.m_type = CCT_SCOPE then
              begin
              // Standard funcitonality support by scope items
                m_pConsoleVerb.SetVerbState(MMC_VERB_OPEN, HIDDEN, FALSE);
                m_pConsoleVerb.SetVerbState(MMC_VERB_OPEN, ENABLED, TRUE);

                m_pConsoleVerb.SetVerbState(MMC_VERB_REFRESH, HIDDEN, FALSE);
                m_pConsoleVerb.SetVerbState(MMC_VERB_REFRESH, ENABLED, TRUE);

              // Enable properties for static node only.
                if internal^.m_cookie = 0 then
                begin
                  m_pConsoleVerb.SetVerbState(MMC_VERB_PROPERTIES, ENABLED, TRUE);
                  //m_pConsoleVerb->SetDefaultVerb(MMC_VERB_PROPERTIES);
                  m_pConsoleVerb.SetDefaultVerb(MMC_VERB_OPEN)
                end
                else
                  m_pConsoleVerb.SetDefaultVerb(MMC_VERB_OPEN);

              // Standard funcitonality NOT support by scope items
                m_pConsoleVerb.SetVerbState(MMC_VERB_DELETE, HIDDEN, TRUE)
              end
              else
              begin
              // Standard funcitonality support by result items
                m_pConsoleVerb.SetVerbState(MMC_VERB_REFRESH, HIDDEN, FALSE);
                m_pConsoleVerb.SetVerbState(MMC_VERB_REFRESH, ENABLED, TRUE);
                m_pConsoleVerb.SetVerbState(MMC_VERB_DELETE, HIDDEN, FALSE);
                m_pConsoleVerb.SetVerbState(MMC_VERB_DELETE, ENABLED, TRUE);
                m_pConsoleVerb.SetDefaultVerb(MMC_VERB_NONE)
              end;

              // Standard funcitonality NOT support by result items

              m_pConsoleVerb.SetVerbState(MMC_VERB_RENAME, ENABLED, TRUE);

              // Standard funcitonality NOT support by all items
              m_pConsoleVerb.SetVerbState(MMC_VERB_COPY, HIDDEN, TRUE);
              m_pConsoleVerb.SetVerbState(MMC_VERB_PASTE, HIDDEN, TRUE)
            end
        finally
          if Assigned (internal) then GlobalFree (THandle (internal))
        end
      end
    end
end;

procedure TIComponent.GetItemName (dataObject : IDataObject; name : PWideChar);
var
  internal : PInternal;
  pData : PResultData;
  folder : TFolder;
begin
  Assert (Assigned (name));
  name [0] := #0;

  internal := ExtractInternalFormat (dataObject);
  if Assigned (internal) then
  try
    if internal^.m_type = CCT_RESULT then
    begin
      if m_bVirtualView then
        pData := GetVirtualResultItem (internal^.m_cookie)
      else
        pData := PResultData (internal^.m_cookie);

      Assert (Assigned (pData));
      lstrcpyw (name, pData^.szName);
    end
    else
    begin
      folder := TFolder (internal^.m_cookie);
      if not Assigned (folder) then
        lstrcpyw (name, 'Static Folder')
      else
        lstrcpyw (name, folder.FolderName);
    end
  finally
    GlobalFree (THandle (Internal))
  end
  else
    Assert (False)
end;

function TIComponent.ExtendControlbarSetControlbar(const pControlbar: IControlbar): HResult;
var
  bmp : HBitmap;
begin
  if Assigned (pControlbar) then
  begin
    m_pControlbar := pControlbar;

    if not Assigned (m_pMenuButton1) then
      OleCheck (m_pControlbar.Create(MENUBUTTON, self, IUnknown (m_pMenuButton1)));

    OleCheck (m_pMenuButton1.AddButton (1002, 'FolderEx', 'Extended Folder Menu'));
    OleCheck (m_pMenuButton1.AddButton (1001, 'FileEx', 'Extended File Menu'));

    if not Assigned (m_pToolbar1) then
    begin
      OleCheck (m_pControlbar.Create (TOOLBAR, self, IUnknown (m_pToolbar1)));

      bmp := LoadBitmap (HInstance, 'BMPTOOLBAR1');
      if bmp <> 0 then
      try
        OleCheck (m_pToolbar1.AddBitmap(11, bmp, 16, 16, RGB(255, 0, 255)));
        OleCheck (m_pToolbar1.AddButtons (High (snapinButtons) + 1, snapinbuttons [0]));
      finally
        DeleteObject (bmp)
      end
      else Assert (False)
    end;

    if not Assigned (m_pToolbar2) then
    begin
      OleCheck (m_pControlbar.Create(TOOLBAR, self, IUnknown (m_pToolbar2)));

      bmp := LoadBitmap (HInstance, 'BMPTOOLBAR2');
      if bmp <> 0 then
      try
        OleCheck (m_pToolbar2.AddBitmap(36, bmp, 16, 16, RGB(192, 192, 192)));
        OleCheck (m_pToolbar2.AddButtons (High (snapinButtons2) + 1, snapinbuttons2 [0]));
      finally
        DeleteObject (bmp);
      end
      else Assert (False)
    end
  end;

   result := S_OK;
end;

procedure EnableToolbar (pToolbar : IToolbar; rgSnapinButtons : PMMCButton; rgSize : Integer; bEnable : BOOL);
var
  i : Integer;
begin
  for i := 0 to rgSize - 1 do
  begin
    if rgSnapinButtons^.idCommand <> 0 then
      pToolbar.SetButtonState (rgSnapinButtons^.idCommand, ENABLED, bEnable);
    Inc (rgSnapinButtons)
  end
end;

procedure EnableMenuBtns (pMenuBtn : IMenuButton; rgSnapinButtons : PMMCButton; rgSize : Integer; bEnable : boolean);
var
  i : Integer;
begin
  for i := 0 to rgSize - 1 do
  begin
    if rgSnapinButtons^.idCommand <> 0 then
      pMenuBtn.SetButtonState (rgSnapinButtons^.idCommand, ENABLED, bEnable);
    Inc (rgSnapinButtons)
  end
end;

function TIComponent.HandleExtToolbars(bDeselectAll : boolean; arg, param : LongInt) : HRESULT;
var
  internal : PInternal;
  dataObject : IDataObject;
  bScope, bSelect : WORDBOOL;
  bFileExBtn : boolean;
  folder : TFolder;

begin
  result := S_OK;
  if param <> 0 then
  begin
    dataObject := IDataObject (param);
    internal := ExtractInternalFormat (dataObject)
  end
  else internal := Nil;

  bScope := WORDBOOL (LOWORD (arg));
  bSelect := WORDBOOL (HIWORD (arg));

  if bDeselectAll or not bSelect then
  begin
    Assert (Assigned (m_pToolbar1));
    EnableToolbar (m_pToolbar1, @SnapinButtons [0], High (SnapinButtons) + 1, FALSE);

    Assert (Assigned (m_pToolbar2));
    EnableToolbar (m_pToolbar2, @SnapinButtons2 [0], High (SnapinButtons2) + 1, FALSE);

    Assert (Assigned (m_pMenuButton1));
    m_pMenuButton1.SetButtonState (1001, ENABLED, FALSE);
    m_pMenuButton1.SetButtonState (1002, ENABLED, FALSE)
  end
  else
  begin
    if not Assigned (internal) then Exit;
    Assert (bSelect);
    bFileExBtn := false;
    if bScope then
    begin
      folder := TFolder (internal^.m_cookie);

      if not Assigned (folder) then
      begin
        if IsPrimaryImpl then
        begin
          OleCheck (m_pControlbar.Attach (TOOLBAR, m_pToolbar1));
          OleCheck (m_pControlbar.Attach (TOOLBAR, m_pToolbar2))
        end
      end
      else
        if (IsPrimaryImpl and (folder.FolderType = ftCompany)) or
           (not IsPrimaryImpl and (folder.FolderType = ftExt_Company)) then
        begin
          // Detach the toolbar2 from the window
          OleCheck (m_pControlbar.Detach (m_pToolbar2));
          OleCheck (m_pControlbar.Attach (TOOLBAR, m_pToolbar1));
        end
        else
          if (IsPrimaryImpl and (folder.FolderType = ftUser)) or
             (not IsPrimaryImpl and (folder.FolderType = ftExt_User)) then
          begin
            OleCheck (m_pControlbar.Detach (m_pToolbar1));
            OleCheck (m_pControlbar.Attach (TOOLBAR, m_pToolbar2))
          end
          else
          begin
            OleCheck (m_pControlbar.Detach (m_pToolbar1));
            OleCheck (m_pControlbar.Detach (m_pToolbar2));
          end;

      EnableToolbar (m_pToolbar1, @SnapinButtons [0], High (SnapinButtons) + 1, FALSE);
      EnableToolbar (m_pToolbar2, @SnapinButtons2 [0], High (SnapinButtons2) + 1, FALSE)
    end
    else // result item selected.
      if internal.m_type = CCT_RESULT then
      begin
        bFileExBtn := true;
        Assert (Assigned (m_pToolbar1));
        EnableToolbar (m_pToolbar1, @SnapinButtons [0], High (SnapinButtons) + 1, TRUE);

        m_pToolbar1.SetButtonState(1, ENABLED,       FALSE);
        m_pToolbar1.SetButtonState(2, CHECKED,       TRUE);
        m_pToolbar1.SetButtonState(3, HIDDEN,        TRUE);
        m_pToolbar1.SetButtonState(4, INDETERMINATE, TRUE);
        m_pToolbar1.SetButtonState(5, BUTTONPRESSED, TRUE);

        // Above is the correct way
        Assert (Assigned (m_pToolbar2));
        m_pToolbar2.SetButtonState(20, CHECKED,       TRUE);
        m_pToolbar2.SetButtonState(30, HIDDEN,        TRUE);
        m_pToolbar2.SetButtonState(40, INDETERMINATE, TRUE);
        m_pToolbar2.SetButtonState(50, BUTTONPRESSED, TRUE);

        EnableToolbar (m_pToolbar2, @SnapinButtons2 [0], High (SnapinButtons2) + 1, TRUE);
      end
      else // sub folder slected
      begin
        folder := TFolder (internal^.m_cookie);
        Assert (Assigned (m_pControlbar));

        if not Assigned (folder) then
        begin
          if IsPrimaryImpl then
          begin
            OleCheck (m_pControlbar.Attach (TOOLBAR, m_pToolbar1));
            OleCheck (m_pControlbar.Attach (TOOLBAR, m_pToolbar2));
          end
        end
        else
          if IsPrimaryImpl and (folder.FolderType = ftCOMPANY) or
             not IsPrimaryImpl and  (folder.FolderType = ftExt_Company) then
          begin
            OleCheck (m_pControlbar.Detach (m_pToolbar2));
            OleCheck (m_pControlbar.Attach (TOOLBAR, m_pToolbar1))
          end
          else
            if IsPrimaryImpl and (folder.FolderType = ftUSER) or
               not IsPrimaryImpl and  (folder.FolderType = ftExt_User) then
            begin
              OleCheck (m_pControlbar.Detach (m_pToolbar1));
              OleCheck (m_pControlbar.Attach (TOOLBAR, m_pToolbar2))
            end
            else
            begin
              OleCheck (m_pControlbar.Detach (m_pToolbar1));
              OleCheck (m_pControlbar.Detach (m_pToolbar2))
            end;

            Assert (Assigned (m_pToolbar1));
            EnableToolbar (m_pToolbar1, @SnapinButtons [0], High (SnapinButtons) + 1, TRUE);

            m_pToolbar1.SetButtonState(1, ENABLED,       FALSE);
            m_pToolbar1.SetButtonState(2, CHECKED,       TRUE);
            m_pToolbar1.SetButtonState(3, ENABLED,       TRUE);
            m_pToolbar1.SetButtonState(4, INDETERMINATE, TRUE);
            m_pToolbar1.SetButtonState(5, BUTTONPRESSED, TRUE);


            Assert (Assigned (m_pToolbar2));
            EnableToolbar(m_pToolbar2, @SnapinButtons2 [0], High (SnapinButtons2) + 1, TRUE);

            // Above is the correct way
            m_pToolbar2.SetButtonState(20, CHECKED,       FALSE);
            m_pToolbar2.SetButtonState(30, ENABLED,       TRUE);
            m_pToolbar2.SetButtonState(40, INDETERMINATE, FALSE);
            m_pToolbar2.SetButtonState(50, BUTTONPRESSED, TRUE);
      end;

    if Assigned (m_pMenuButton1) then
    begin
        // Always make sure the menuButton is attached
      m_pControlbar.Attach (MENUBUTTON, m_pMenuButton1);

      if bFileExBtn then
      begin
        m_pMenuButton1.SetButtonState(1001, HIDDEN, FALSE);
        m_pMenuButton1.SetButtonState(1002, HIDDEN, TRUE);
        m_pMenuButton1.SetButtonState(1001, ENABLED, TRUE)
      end
      else
      begin
        m_pMenuButton1.SetButtonState (1002, HIDDEN, FALSE);
        m_pMenuButton1.SetButtonState (1001, HIDDEN, TRUE);
        m_pMenuButton1.SetButtonState (1002, ENABLED, TRUE);
      end
    end
  end
end;

procedure TIComponent.HandleExtMenus (arg, param : LongInt);
var
  dataObject : IDataObject;
  menuData : PMenuButtondata;
  menu, submenu : HMenu;
  frame : HWND;
begin
  dataObject := IDataObject (arg);
  menuData := PMenuButtonData (param);

  if not Assigned (dataObject) or not Assigned (menuData) then
  begin
    Assert (False);
    Exit
  end;

  case menuData^.idCommand of
    1002 :
      begin
        menu := LoadMenu (hInstance, MakeIntResource (1002));
        subMenu := GetSubMenu (menu, 0)
      end;

    1001 :
      begin
        menu := LoadMenu (hInstance, MakeIntResource (1001));
        subMenu := GetSubMenu (menu, 0)
      end;

    else
      Assert (false)
  end;

  fConsole.GetMainWindow (frame);
  TrackPopupMenu (subMenu, TPM_RETURNCMD or TPM_NONOTIFY, menuData^.x, menuData^.y, 0, frame, Nil)
end;

function TIComponent.ExtendControlbarControlbarNotify(event: MMC_NOTIFY_TYPE; arg, param: Integer): HResult;
begin
  case event of
    MMCN_BTN_CLICK     : OnButtonClick (IDataObject (arg), param);
    MMCN_DESELECT_ALL  : HandleExtToolbars(True, arg, param);
    MMCN_SELECT        : HandleExtToolbars(False, arg, param);
    MMCN_MENU_BTNCLICK : HandleExtMenus(arg, param);
  end;

  result := S_OK;
end;

function TIComponent.ResultDataCompareCompare (lUserParam, cookieA, cookieB: Integer; var pnResult: SYSINT): HResult;
var
  nCol : Integer;
  szStringA, szStringB : PWideChar;
  pDataA, pDataB : PResultData;
begin
  nCol := pnResult;
  Assert ((nCol >= 0) and (nCol < 3));
  pnResult := 0;

  pDataA := PResultData (cookieA);
  pDataB := PResultData (cookieB);

  Assert (Assigned (pDataA) and Assigned (pDataB));

  if nCol = 0 then
  begin
    szStringA := pDataA^.szName;
    szStringB := pDataB^.szName
  end
  else
    if nCol = 1 then
    begin
      szStringA := pDataA^.szSize;
      szStringB := pDataB^.szSize
    end
    else
    begin
      szStringA := pDataA^.szType;
      szStringB := pDataB^.szType
    end;

  Assert (Assigned (szStringA) and Assigned (szStringB));

  pnResult := lstrcmpw (szStringA, szStringB);

  result := S_OK;
end;

///////////////////////////////////////////////////////////////////////////////
// IResultOwnerData implementation
//
function TIComponent.ResultOwnerDataFindItem (var pFindInfo: TResultFindInfo; out pnFoundIndex: SYSINT): HResult;
var
  nMatchVal, nStartVal, nScale, nTestVal, nTargetVal : Integer;
  lpszFind : PWideChar;
  pch : PWideChar;

begin
    // find next item that matches the string (exact or partial)
    // if matched found, set FoundIndex and return S_OK

    // For the sample all items are named by their index number
    // so we don't do a real string search. Also, to simplify the code
    // the routine assumes a partial match search with wrap, which is what
    // keyboard navigation calls use.

  Assert (pFindInfo.dwOptions and (RFI_PARTIAL or RFI_WRAP) = RFI_PARTIAL or RFI_WRAP);

  nMatchVal := 0;
  lpszFind := pFindInfo.psz;
  pch := lpszFind;

  while (pch^ >= '0') and (pch^ <= '9') and (nMatchVal < NUM_VIRTUAL_ITEMS) do
  begin
    nMatchVal := nMatchVal * 10 + (Ord (pch^) - Ord ('0'));
    Inc (pch)
  end;

  if (pch^ <> #0) or (nMatchVal >= NUM_VIRTUAL_ITEMS) then
    result := S_FALSE
  else
  begin
    if (m_dwVirtualSortOptions and RSI_DESCENDING) = 0 then
    begin
      nStartVal := pFindInfo.nStart;
        // if match is less than start (but not zero), locate first value above start that matches
        // otherwise the match number itself it the answer
      if (nMatchVal < nStartVal) and (nMatchVal <> 0) then
      begin
        nScale := 1;
        while nMatchVal * nScale < nStartVal do
          nScale := nScale * 10;

            // check special case of start value beginning with the match digits
        if (nStartVal * 10 - nMatchVal * nScale) < nScale then
          nTestVal := nScale
        else
          nTestVal := nMatchVal * nScale;

            // if not too big it's the match, else the match value is the match
        if nTestVal < NUM_VIRTUAL_ITEMS then
          nMatchVal := nTestVal;
      end
    end
    else  // descending sequence
    begin
        // convert start index to start value
      nStartVal := (NUM_VIRTUAL_ITEMS - 1) - pFindInfo.nStart;

      if nMatchVal <> 0 then
      begin
        // if match number > start, we will have to wrap to find a match
        // so use max index as our target
        if nMatchVal > nStartVal then
          nTargetVal := NUM_VIRTUAL_ITEMS - 1
        else
          nTargetVal := nStartVal;

        nScale := 1;

            // find scale factor that gets closest without going over target
        while nMatchVal * nScale * 10 < nTargetVal do
          nScale := nScale * 10;

           // check special case of target value beginning with the match digits
        if (nTargetVal - nMatchVal* nScale) < nScale then
          nMatchVal := nTargetVal
        else
          nMatchVal := (nMatchVal + 1) * nScale - 1
      end;

        // convert match value back to an item index
      nMatchVal := (NUM_VIRTUAL_ITEMS - 1) - nMatchVal;
    end;

    pnFoundIndex := nMatchVal;

    result := S_OK
  end
end;

function TIComponent.ResultOwnerDataCacheHint(nStartIndex, nEndIndex: SYSINT): HResult;
begin
  result := S_OK
end;

function TIComponent.ResultOwnerDataSortItems(nColumn: SYSINT; dwSortOptions: UINT; lUserParam: Integer): HResult;
begin
    // sort request for user owned result items
    // if item order changed return S_OK, else S_FALSE

    // Sample only sorts on the first column (item name)

  if (nColumn = 0) and (m_dwVirtualSortOptions <> dwSortOptions) then
  begin
    m_dwVirtualSortOptions := dwSortOptions;
    result := S_OK
  end
  else
    result := S_FALSE
end;

function TIComponent.PersistStreamIsDirty: HResult;
begin
  if m_bIsDirty then
    result := S_OK
  else
    result := S_FALSE;
end;

function TIComponent.PersistStreamLoad (const stm: IStream): HResult;
var
  psz : array [0..9] of char;
  nBytesRead : Longint;
begin
  Assert (m_bInitialized);

  result := stm.Read (@psz [0], 10, @nBytesRead);
  Assert (Succeeded (result) and (nBytesRead = 10));
  Assert (lstrcmp (psz, '987654321') = 0);
  m_bIsDirty := False;
  if Succeeded (result) then
    result := S_OK
  else
    result := E_FAIL
end;

function TIComponent.PersistStreamSave (const stm: IStream; fClearDirty: BOOL): HResult;
var
  nBytesWritten : Longint;
begin
  Assert (m_bInitialized);
  result := stm.Write (PChar ('987654321'), 10, @nBytesWritten);

  Assert (Succeeded (result) and (nBytesWritten = 10));
  if Failed (result) then
    result := STG_E_CANTSAVE
  else
  begin
    m_bIsDirty := False;
    result := S_OK
  end
end;

function TIComponent.PersistStreamGetSizeMax (out cbSize: Largeint): HResult;
begin
  cbSize := 10;
end;

function TIComponent.PersistStreamGetClassID (out classID: TCLSID): HResult; stdcall;
begin
  classID := Class_TTestSnapin;

  result := E_NOTIMPL;
end;

end.
