(*============================================================================*
 | Microsoft Management Console interface unit for Delphi 3                   |
 |                                                                            |
 | Translated into Delphi by Colin Wilson.  February 1998.                    |
 |                                                                            |
 | Translation copyright (c) Colin Wilson.  All rights reserved               |
 *============================================================================*)

unit mmc;

interface

uses Windows, commctrl, activeX;

const
  MMCLV_AUTO                   = -1;
  MMCLV_NOPARAM                = -2;
  MMCLV_NOICON                 = -1;
  MMCLV_VIEWSTYLE_ICON         = 0;
  MMCLV_VIEWSTYLE_SMALLICON    = $2;
  MMCLV_VIEWSTYLE_LIST         = $3;
  MMCLV_VIEWSTYLE_REPORT       = $1;
  MMCLV_NOPTR                  = 0;
  MMCLV_UPDATE_NOINVALIDATEALL = $1;
  MMCLV_UPDATE_NOSCROLL        = $2;

  RDI_STR    = $2;
  RDI_IMAGE  = $4;
  RDI_STATE  = $8;
  RDI_PARAM  = $10;
  RDI_INDEX  = $20;
  RDI_INDENT = $40;

  MMC_SINGLESEL     = $1;
  MMC_SHOWSELALWAYS = $2;
  MMC_NOSORTHEADER  = $4;

  MMC_VIEW_OPTIONS_NONE          = 0;
  MMC_VIEW_OPTIONS_NOLISTVIEWS   = $1;
  MMC_VIEW_OPTIONS_MULTISELECT   = $2;
  MMC_VIEW_OPTIONS_OWNERDATALIST = $4;
  MMC_VIEW_OPTIONS_FILTERED      = $8;
  MMC_VIEW_OPTIONS_CREATENEW     = $10;

  MMC_PSO_NOAPPLYNOW    = $1;
  MMC_PSO_HASHELP       = $2;
  MMC_PSO_NEWWIZARDTYPE = $4;

  //  MMC_CONSOLE_VERB enum
  MMC_VERB_NONE       = 0;
  MMC_VERB_OPEN       = $8000;
  MMC_VERB_COPY       = $8001;
  MMC_VERB_PASTE      = $8002;
  MMC_VERB_DELETE     = $8003;
  MMC_VERB_PROPERTIES = $8004;
  MMC_VERB_RENAME     = $8005;
  MMC_VERB_REFRESH    = $8006;
  MMC_VERB_PRINT      = $8007;

  // MMC_BUTTON_STATE enum
  ENABLED       = $1;
  CHECKED       = $2;
  HIDDEN        = $4;
  INDETERMINATE = $8;
  BUTTONPRESSED = $10;

  RFI_PARTIAL = $1;
  RFI_WRAP    = $2;

  RSI_DESCENDING = $1;
  SDI_STR        = $2;
  SDI_IMAGE      = $4;
  SDI_OPENIMAGE  = $8;
  SDI_STATE      = $10;
  SDI_PARAM      = $20;
  SDI_CHILDREN   = $40;
  SDI_PARENT     = 0;
  SDI_PREVIOUS   = $10000000;
  SDI_NEXT       = $20000000;
  SDI_FIRST      = $8000000;


  // MMC_SCOPE_ITEM_STATE enum
  MMC_SCOPE_ITEM_STATE_NORMAL       = $1;
  MMC_SCOPE_ITEM_STATE_BOLD         = $2;
  MMC_SCOPE_ITEM_STATE_EXPANDEDONCE = $3;

  // MMC_MENU_COMMAND_IDS enum
  MMCC_STANDARD_VIEW_SELECT = -1;

  MMC_MULTI_SELECT_COOKIE = -2;


  // MMC_NOTIFY_TYPE enum
  MMCN_ACTIVATE        = $8001;
  MMCN_ADD_IMAGES      = $8002;
  MMCN_BTN_CLICK       = $8003;
  MMCN_CLICK           = $8004;
  MMCN_COLUMN_CLICK    = $8005;
  MMCN_CONTEXTMENU     = $8006;
  MMCN_CUTORMOVE       = $8007;
  MMCN_DBLCLICK        = $8008;
  MMCN_DELETE          = $8009;
  MMCN_DESELECT_ALL    = $800a;
  MMCN_EXPAND          = $800b;
  MMCN_HELP            = $800c;
  MMCN_MENU_BTNCLICK   = $800d;
  MMCN_MINIMIZED       = $800e;
  MMCN_PASTE           = $800f;
  MMCN_PROPERTY_CHANGE = $8010;
  MMCN_QUERY_PASTE     = $8011;
  MMCN_REFRESH         = $8012;
  MMCN_REMOVE_CHILDREN = $8013;
  MMCN_RENAME          = $8014;
  MMCN_SELECT          = $8015;
  MMCN_SHOW            = $8016;
  MMCN_VIEW_CHANGE     = $8017;
  MMCN_SNAPINHELP      = $8018;
  MMCN_CONTEXTHELP     = $8019;
  MMCN_INITOCX         = $801a;

// DATA_OBJECT_TYPES enum
   CCT_SCOPE          = $8000;
   CCT_RESULT         = $8001;
   CCT_SNAPIN_MANAGER = $8002;
   CCT_UNINITIALIZED  = $ffff;

  MMC_NW_OPTION_LONGTITLE = 0;
  MMC_NW_OPTION_SHORTTITLE = $1;

  CCF_NODETYPE                     = 'CCF_NODETYPE';
  CCF_SZNODETYPE                   = 'CCF_SZNODETYPE';
  CCF_DISPLAY_NAME                 = 'CCF_DISPLAY_NAME';
  CCF_SNAPIN_CLASSID               = 'CCF_SNAPIN_CLASSID';
  CCF_MMC_MULTISELECT_DATAOBJECT   = 'CCF_MMC_MULTISELECT_DATAOBJECT';
  CCF_MULTI_SELECT_SNAPINS         = 'CCF_MULTI_SELECT_SNAPINS';
  CCF_OBJECT_TYPES_IN_MULTI_SELECT = 'CCF_OBJECT_TYPES_IN_MULTI_SELECT';


CCM_INSERTIONPOINTID_MASK_SPECIAL        = $ffff0000;
CCM_INSERTIONPOINTID_MASK_SHARED         = $80000000;
CCM_INSERTIONPOINTID_MASK_CREATE_PRIMARY = $40000000;
CCM_INSERTIONPOINTID_MASK_ADD_PRIMARY    = $20000000;
CCM_INSERTIONPOINTID_MASK_ADD_3RDPARTY   = $10000000;
CCM_INSERTIONPOINTID_MASK_RESERVED       = $fff0000;
CCM_INSERTIONPOINTID_MASK_FLAGINDEX      = $1f;
CCM_INSERTIONPOINTID_PRIMARY_TOP         = $a0000000;
CCM_INSERTIONPOINTID_PRIMARY_NEW         = $a0000001;
CCM_INSERTIONPOINTID_PRIMARY_TASK        = $a0000002;
CCM_INSERTIONPOINTID_PRIMARY_VIEW        = $a0000003;
CCM_INSERTIONPOINTID_3RDPARTY_NEW        = $90000001;
CCM_INSERTIONPOINTID_3RDPARTY_TASK       = $90000002;
CCM_INSERTIONPOINTID_ROOT_MENU           = $80000000;

CCM_INSERTIONALLOWED_TOP = 1 shl (CCM_INSERTIONPOINTID_PRIMARY_TOP and CCM_INSERTIONPOINTID_MASK_FLAGINDEX);
CCM_INSERTIONALLOWED_NEW = 1 shl (CCM_INSERTIONPOINTID_PRIMARY_NEW and CCM_INSERTIONPOINTID_MASK_FLAGINDEX);
CCM_INSERTIONALLOWED_TASK = 1 shl (CCM_INSERTIONPOINTID_PRIMARY_TASK and CCM_INSERTIONPOINTID_MASK_FLAGINDEX);
CCM_INSERTIONALLOWED_VIEW = 1 shl (CCM_INSERTIONPOINTID_PRIMARY_VIEW and CCM_INSERTIONPOINTID_MASK_FLAGINDEX);

(*
enum __MIDL___MIDL_itf_mmc_0099_0003
    {CCM_COMMANDID_MASK_RESERVED= $ffff0000
    };

*)

CCM_SPECIAL_SEPARATOR       = $1;
CCM_SPECIAL_SUBMENU         = $2;
CCM_SPECIAL_DEFAULT_ITEM    = $4;
CCM_SPECIAL_INSERTION_POINT = $8;
CCM_SPECIAL_TESTONLY        = $10;

(*
extern RPC_IF_HANDLE __MIDL_itf_mmc_0099_v0_0_c_ifspec;
extern RPC_IF_HANDLE __MIDL_itf_mmc_0099_v0_0_s_ifspec;

*)

  IID_IComponentData         = '{955AB28A-5218-11D0-A985-00C04FD8D565}';
  IID_IComponent             = '{43136EB2-D36C-11CF-ADBC-00AA00A80033}';
  IID_IConsole               = '{43136EB1-D36C-11CF-ADBC-00AA00A80033}';
  IID_IResultDataCompare     = '{E8315A52-7A1A-11D0-A2D2-00C04FD909DD}';
  IID_IResultOwnerData       = '{9CB396D8-EA83-11d0-AEF1-00C04FB6DD2C}';
  IID_IHeaderCtrl            = '{43136EB3-D36C-11CF-ADBC-00AA00A80033}';
  IID_IToolbar               = '{43136EB9-D36C-11CF-ADBC-00AA00A80033}';
  IID_IImageList             = '{43136EB8-D36C-11CF-ADBC-00AA00A80033}';
  IID_IConsoleVerb           = '{E49F7A60-74AF-11D0-A286-00C04FD8FE93}';
  IID_IContextMenuCallback   = '{43136EB7-D36C-11CF-ADBC-00AA00A80033}';
  IID_IContextMenuProvider   = '{43136EB6-D36C-11CF-ADBC-00AA00A80033}';
  IID_IExtendContextMenu     = '{4F3B7A4F-CFAC-11CF-B8E3-00C04FD8D5B0}';
  IID_IResultData            = '{31DA5FA0-E0EB-11cf-9F21-00AA003CA9F6}';
  IID_IQuickFilter           = '{9757abb8-1b32-11d1-a7ce-00c04fd8d565}';
  IID_IConsoleNameSpace      = '{BEDEB620-F24D-11cf-8AFC-00AA003CA9F6}';
  IID_IPropertySheetCallback = '{85DE64DD-EF21-11cf-A285-00C04FD8DBE6}';
  IID_IPropertySheetProvider = '{85DE64DE-EF21-11cf-A285-00C04FD8DBE6}';
  IID_IExtendPropertySheet   = '{85DE64DC-EF21-11cf-A285-00C04FD8DBE6}';
  IID_IControlBar            = '{69FB811E-6C1C-11D0-A2CB-00C04FD909DD}';
  IID_IExtendControlbar      = '{49506520-6F40-11D0-A98B-00C04FD8D565}';
  IID_ISnapinAbout           = '{1245208C-A151-11D0-A7D7-00C04FD909DD}';
  IID_IMenuButton            = '{951ED750-D080-11d0-B197-000000000000}';
  IID_ISnapinHelp            = '{A6B15ACE-DF59-11D0-A7DD-00C04FD909DD}';

  MMC_CALLBACK = PWideChar (-1); 
type
  PDataObject = IDataObject;
  HSCOPEITEM = LongInt;
  COMPONENTID = longInt;
  HRESULTITEM = LongInt;
  MMC_RESULT_VIEW_STYLE = LongInt;
  MMC_CONSOLE_VERB = LongInt;
  MMC_BUTTON_STATE = LongInt;
  MMC_SCOPE_ITEM_STATE = LongInt;
  MMC_MENU_COMMAND_IDS = LongInt;
  MMC_NOTIFY_TYPE = LongInt;
  DATA_OBJECT_TYPES = LongInt;

  MMC_CONTROL_TYPE = (TOOLBAR, MENUBUTTON, COMBOBOXBAR);

  _userBITMAP = record
    bmType: Integer;
    bmWidth: Integer;
    bmHeight: Integer;
    bmWidthBytes: Integer;
    bmPlanes: Word;
    bmBitsPixel: Word;
    cbSize: UINT;
    pBuffer: Shortint;
  end;

  __MIDL_IWinTypes_0007 = record
    case Integer of
      0: (hInproc: Integer);
      1: (hRemote: _userBITMAP);
      2: (hGlobal: Integer);
  end;

  _userHBITMAP = record
    fContext: Integer;
    u: __MIDL_IWinTypes_0007;
  end;

  wireHBITMAP = _userHBITMAP;


  __MIDL_IWinTypes_0009 = record
    case Integer of
      0: (hInproc: Integer);
      1: (hRemote: Integer);
  end;

  _RemotableHandle = record
    fContext: Integer;
    u: __MIDL_IWinTypes_0009;
  end;

  wireHWND = _RemotableHandle;

const
// EXTERN_C const CLSID CLSID_NodeManager;

   DOBJ_NULL      = Ptr (0);
   DOBJ_CUSTOMOCX = Ptr (-1);                                         
   DOBJ_CUSTOMWEB = Ptr (-2);

type
  TMMCButton = record
    nBitmap : SYSINT;
    idCommand : SYSINT;
    fsState : byte;
    fsType : byte;
    lpButtonText : PWideChar;
    lpTooltipText : PWideChar
  end;
  PMMCButton = ^TMMCButton;

  TResultDataItem = record
    mask : DWORD;
    bScopeItem : BOOL;
    itemID : HRESULTITEM;
    nIndex : Integer;
    nCol : Integer;
    str : POleStr;
    nImage : Integer;
    nState : DWORD;
    lParam : LPARAM;
    iIndent : Integer
  end;
  PResultDataItem = ^TResultDataItem;

  TResultFindInfo = record
    psz : POleStr;
    nStart : Integer;
    dwOptions : DWORD
  end;
  PResultFindInfo = ^TResultFindInfo;

  TScopeDataItem = record
    mask: UINT;
    displayname: PWideChar;
    nImage: SYSINT;
    nOpenImage: SYSINT;
    nState: SYSUINT;
    cChildren: SYSINT;
    lParam: Integer;
    relativeID: Integer;
    ID: Integer;
  end;
  PScopeDataItem = ^TScopeDataItem;

  TContextMenuItem = record
    strName : PWideChar;
    strStatusBarText : PWideChar;
    lCommandID : LongInt;
    lInsertionPointID : LongInt;
    fFlags : LongInt;
    fSpecialFlags : LongInt
  end;
  PContextMenuItem = ^TContextMenuItem;

  TMenuButtonData = record
    idCommand : Integer;
    x : Integer;
    y : Integer
  end;
  PMenuButtonData = ^TMenuButtonData;

  TSMMCDataObjects = record
    count : DWORD;
    lpDataObject : array [0..0] of IDataObject
  end;


  TSMMCObjectTypes = record
    count : DWORD;
    guid : array [0..0] of TGUID
  end;

//function MMCPropertyChangeNotify (lNotifyHandle, param : LongInt) : HResult; stdcall;
//function MMCFreeNotifyHandle (lNotifyHandle : LongInt) : HResult; stdcall;
//function MMCPropPageCallback (vpsp : pointer) : HResult; stdcall;

//extern RPC_IF_HANDLE __MIDL_itf_mmc_0000_v0_0_c_ifspec;
//extern RPC_IF_HANDLE __MIDL_itf_mmc_0000_v0_0_s_ifspec;

type

IControlbar = interface;

IExtendControlbar = interface (IUnknown)    // Checked
[IID_IExtendControlbar]
  function SetControlbar(const pControlbar: IControlbar): HResult; stdcall;
  function ControlbarNotify(event: MMC_NOTIFY_TYPE; arg, param: Integer): HResult; stdcall;
end;

IControlbar = interface (IUnknown)         // Checked
[IID_IControlBar]
  function Create(nType: MMC_CONTROL_TYPE; const pExtendControlbar: IExtendControlbar; out ppUnknown: IUnknown): HResult; stdcall;
  function Attach(nType: MMC_CONTROL_TYPE; lpUnknown: IUnknown): HResult; stdcall;
  function Detach(lpUnknown: IUnknown): HResult; stdcall;
end;

IHeaderCtrl = interface(IUnknown)          // Checked
[IID_IHeaderCtrl]
  function InsertColumn(nCol: SYSINT; title: PWideChar; nFormat, nWidth: SYSINT): HResult; stdcall;
  function DeleteColumn(nCol: SYSINT): HResult; stdcall;
  function SetColumnText(nCol: SYSINT; title: PWideChar): HResult; stdcall;
  function GetColumnText(nCol: SYSINT; out pText: PWideChar): HResult; stdcall;
  function SetColumnWidth(nCol, nWidth: SYSINT): HResult; stdcall;
  function GetColumnWidth(nCol: SYSINT; out pWidth: SYSINT): HResult; stdcall;
end;

IToolbar = interface(IUnknown)             // Checked
[IID_IToolbar]
//  function AddBitmap(nImages: SYSINT; hbmp: wireHBITMAP; cxSize, cySize: SYSINT; crMask: UINT): HResult; stdcall;

  function AddBitmap(nImages: SYSINT; hbmp: HBITMAP; cxSize, cySize: SYSINT; crMask: UINT): HResult; stdcall;
  function AddButtons(nButtons: SYSINT; var lpButtons: TMMCButton): HResult; stdcall;
  function InsertButton(nIndex: SYSINT; var lpButton: TMMCButton): HResult; stdcall;
  function DeleteButton(nIndex: SYSINT): HResult; stdcall;
  function GetButtonState(idCommand: SYSINT; nState: MMC_BUTTON_STATE; out pState: Integer): HResult; stdcall;
  function SetButtonState(idCommand: SYSINT; nState: MMC_BUTTON_STATE; bState: BOOL): HResult; stdcall;
end;

IImageList = interface(IUnknown)           // Checked
[IID_IImageList]
  function ImageListSetIcon(var pIcon: Integer; nLoc: Integer): HResult; stdcall;

  // ----  They don't really mean 'var' but that's what they've defined, so you need
  // ----  to work around it.
//  function ImageListSetStrip(var pBMapSm, pBMapLg: Integer; nStartLoc: Integer; cMask: UINT): HResult; stdcall;

// ----  This is what they meant!
  function ImageListSetStrip(pBMapSm, pBMapLg: Integer; nStartLoc: Integer; cMask: UINT): HResult; stdcall;
end;

IConsoleVerb = interface(IUnknown)         // Checked
[IID_IConsoleVerb]
  function GetVerbState(eCmdID: MMC_CONSOLE_VERB; nState: MMC_BUTTON_STATE; out pState: Integer): HResult; stdcall;
  function SetVerbState(eCmdID: MMC_CONSOLE_VERB; nState: MMC_BUTTON_STATE; bState: BOOL): HResult; stdcall;
  function SetDefaultVerb(eCmdID: MMC_CONSOLE_VERB): HResult; stdcall;
  function GetDefaultVerb(out peCmdID: MMC_CONSOLE_VERB): HResult; stdcall;
end;

IConsole = interface(IUnknown)             // Checked
[IID_IConsole]
  function SetHeader(const pHeader: IHeaderCtrl): HResult; stdcall;
  function SetToolbar(const pToolbar: IToolbar): HResult; stdcall;
  function QueryResultView(out pUnknown: IUnknown): HResult; stdcall;
  function QueryScopeImageList(out ppImageList: IImageList): HResult; stdcall;
  function QueryResultImageList(out ppImageList: IImageList): HResult; stdcall;
  function UpdateAllViews(const lpDataObject: IDataObject; data, hint: Integer): HResult; stdcall;
  function MessageBox(lpszText, lpszTitle: PWideChar; fuStyle: SYSUINT; out piRetval: SYSINT): HResult; stdcall;
  function QueryConsoleVerb(out ppConsoleVerb: IConsoleVerb): HResult; stdcall;
  function SelectScopeItem(hScopeItem: Integer): HResult; stdcall;
//  function GetMainWindow(out phwnd: wireHWND): HResult; stdcall;
  function GetMainWindow(out phwnd: HWND): HResult; stdcall;
  function NewWindow(hScopeItem: Integer; lOptions: UINT): HResult; stdcall;
end;

IComponent = interface(IUnknown)           // Checked
[IID_ICOMPONENT]
  function Initialize(const lpConsole: IConsole): HResult; stdcall;
  function Notify(const lpDataObject: IDataObject; event: MMC_NOTIFY_TYPE; arg, param: Integer): HResult; stdcall;
  function Destroy(cookie: Integer): HResult; stdcall;
  function QueryDataObject(cookie: Integer; type_: DATA_OBJECT_TYPES; out ppDataObject: IDataObject): HResult; stdcall;
  function GetResultViewType(cookie: Integer; out ppViewType: PWideChar; out pViewOptions: Integer): HResult; stdcall;
  function GetDisplayInfo(var pResultDataItem: TResultDataItem): HResult; stdcall;
  function CompareObjects(const lpDataObjectA, lpDataObjectB: IDataObject): HResult; stdcall;
end;

IComponentData = interface(IUnknown)        // Checked
[IID_IComponentData]
  function Initialize(pUnknown: IUnknown): HResult; stdcall;
  function CreateComponent(out ppComponent: IComponent): HResult; stdcall;
  function Notify(const lpDataObject: IDataObject; event: MMC_NOTIFY_TYPE; arg, param: Integer): HResult; stdcall;
  function Destroy: HResult; stdcall;
  function QueryDataObject(cookie: Integer; type_: DATA_OBJECT_TYPES; out ppDataObject: IDataObject): HResult; stdcall;
  function GetDisplayInfo(var pScopeDataItem: TScopeDataItem): HResult; stdcall;
  function CompareObjects(const lpDataObjectA, lpDataObjectB: IDataObject): HResult; stdcall;
end;

IResultDataCompare = interface (IUnknown)   // Checked
[IID_IRESULTDATACOMPARE]
  function Compare(lUserParam, cookieA, cookieB: Integer; var pnResult: SYSINT): HResult; stdcall;
end;

IResultOwnerData = interface (IUnknown)     // Checked
[IID_IResultOwnerData]
  function FindItem(var pFindInfo: TResultFindInfo; out pnFoundIndex: SYSINT): HResult; stdcall;
  function CacheHint(nStartIndex, nEndIndex: SYSINT): HResult; stdcall;
  function SortItems(nColumn: SYSINT; dwSortOptions: UINT; lUserParam: Integer): HResult; stdcall;
end;

IContextMenuCallback = interface (IUnknown) // Checked
[IID_IContextMenuCallback]
  function AddItem(var pItem: TContextMenuItem): HResult; stdcall;
end;

IContextMenuProvider = interface (IContextMenuCallback) // Checked
[IID_IContextMenuProvider]
  function EmptyMenuList: HResult; stdcall;
  function AddPrimaryExtensionItems(piExtension: IUnknown; const piDataObject: IDataObject): HResult; stdcall;
  function AddThirdPartyExtensionItems(const piDataObject: IDataObject): HResult; stdcall;
  function ShowContextMenu(hwndParent: wireHWND; xPos, yPos: Integer; out Retval: Integer): HResult; stdcall;
end;

IExtendContextMenu = interface (IUnknown)  // Checked
[IID_IExtendContextMenu]
  function AddMenuItems(const piDataObject: IDataObject; const piCallback: IContextMenuCallback; var pInsertionAllowed: Integer): HResult; stdcall;
  function Command(lCommandID: Integer; const piDataObject: IDataObject): HResult; stdcall;
end;

IResultData = interface (IUnknown)
[IID_IResultData]
  function InsertItem(var item: TResultDataItem): HResult; stdcall;
  function DeleteItem(itemID: Integer; nCol: SYSINT): HResult; stdcall;
  function FindItemByLParam(lParam: Integer; out pItemID: Integer): HResult; stdcall;
  function DeleteAllRsltItems: HResult; stdcall;
  function SetItem(var item: TResultDataItem): HResult; stdcall;
  function GetItem(var item: TResultDataItem): HResult; stdcall;
  function GetNextItem(var item: TResultDataItem): HResult; stdcall;
  function ModifyItemState(nIndex: SYSINT; itemID: Integer; uAdd, uRemove: SYSUINT): HResult; stdcall;
  function ModifyViewStyle(add, remove: MMC_RESULT_VIEW_STYLE): HResult; stdcall;
  function SetViewMode(lViewMode: Integer): HResult; stdcall;
  function GetViewMode(out lViewMode: Integer): HResult; stdcall;
  function UpdateItem(itemID: Integer): HResult; stdcall;
  function Sort(nColumn: SYSINT; dwSortOptions: UINT; lUserParam: Integer): HResult; stdcall;
  function SetDescBarText(DescText: PWideChar): HResult; stdcall;
  function SetItemCount(nItemCount: SYSINT; dwOptions: UINT): HResult; stdcall;
end;

IQuickFilter = interface (IUnknown)  // Checked
[IID_IQuickFilter]
  function SetChangeTimeOut (uTimeout : UINT) : HResult; stdcall;
  function SetQuickFilter (nColumn : UINT; lFilter : LongInt) : HResult; stdcall;
  function GetQuickFilter (nColumn : UINT; var lFilter : LongInt) : HResult; stdcall;
end;

IConsoleNameSpace = interface (IUnknown) // Checked
[IID_IConsoleNameSpace]
  function InsertItem (var item : TScopeDataItem) : HResult; stdcall;
  function DeleteItem (hItem : HSCOPEITEM) : HResult; stdcall;
  function SetItem (const item : TScopeDataItem) : HResult; stdcall;
  function GetItem (var item : TScopeDataItem) : HResult; stdcall;
  function GetChildItem (item : HSCOPEITEM; out itemChild : HSCOPEITEM; out cookie : LongInt) : HResult; stdcall;
  function GetNextItem (item : HSCOPEITEM; out itemNext : HSCOPEITEM; out cookie : LongInt) : HResult; stdcall;
  function GetParentItem (item : HSCOPEITEM; out itemParent : HSCOPEITEM; out cookie : LongInt) : HResult; stdcall;
end;

IPropertySheetCallback = interface (IUnknown)  // Not checked
[IID_IPropertySheetCallback]
  function AddPage(hPage : HPropSheetPage) : HResult; stdcall;
  function RemovePage (hPage : HPropSheetPage) : HResult; stdcall;
end;

IPropertySheetProvider = interface (IUnknown)  // Checked
[IID_IPropertySheetProvider]
  function CreatePropertySheet(title: PWideChar; type_: Shortint; cookie: Integer; const pIDataObjectm: IDataObject; dwOptions: UINT): HResult; stdcall;
  function FindPropertySheet(cookie: Integer; const lpComponent: IComponent; const lpDataObject: IDataObject): HResult; stdcall;
  function AddPrimaryPages(lpUnknown: IUnknown; bCreateHandle: Integer; hNotifyWindow: wireHWND; bScopePane: Integer): HResult; stdcall;
  function AddExtensionPages: HResult; stdcall;
  function Show(window: Integer; page: SYSINT): HResult; stdcall;
end;

IExtendPropertySheet = interface (IUnknown)    // Not Checked
[IID_IExtendPropertySheet]
  function CreatePropertyPages (provider : IPropertySheetCallback; handle : LongInt; dataObject : IDataObject) : HResult; stdcall;
  function QueryPagesFor (dataObject : IDataObject) : HResult; stdcall;
end;


ISnapinAbout = interface (IUnknown)
[IID_ISnapinAbout]
  function GetSnapinDescription (var descrpition : PWideChar) : HResult; stdcall;
  function GetProvider (var name : PWideChar) : HResult; stdcall;
  function GetSnapinVersion (var version : PWideChar) : HResult; stdcall;
  function GetSnapinImage (var icon : HICON) : HResult; stdcall;
  function GetStaticFolderImage (var hSmallImage, hSmallImageOpen, hLargeImage : HBITMAP; var cMask : TColorRef) : HResult; stdcall;
end;

IMenuButton = interface (IUnknown)
[IID_IMenuButton]
  function AddButton (idCommand : Integer; buttonText, tooltipText : PWideChar) :HResult; stdcall;
  function SetButton (idCommand : Integer; buttonText, tooltipText : PWideChar) : HResult; stdcall;
  function SetButtonState (idCommand : Integer; nState : MMC_BUTTON_STATE; bState : BOOL) : HResult; stdcall;
end;

ISnapinHelp = interface (IUnknown)
[IID_ISnapinHelp]
  function GetHelpTopic(var compiledHelpFile : PWideChar) : HResult; stdcall;
end;

(*
/* Additional Prototypes for ALL interfaces */

unsigned long             __RPC_USER  HBITMAP_UserSize(     unsigned long __RPC_FAR *, unsigned long            , HBITMAP __RPC_FAR * );
unsigned char __RPC_FAR * __RPC_USER  HBITMAP_UserMarshal(  unsigned long __RPC_FAR *, unsigned char __RPC_FAR *, HBITMAP __RPC_FAR * );
unsigned char __RPC_FAR * __RPC_USER  HBITMAP_UserUnmarshal(unsigned long __RPC_FAR *, unsigned char __RPC_FAR *, HBITMAP __RPC_FAR * );
void                      __RPC_USER  HBITMAP_UserFree(     unsigned long __RPC_FAR *, HBITMAP __RPC_FAR * );

unsigned long             __RPC_USER  HICON_UserSize(     unsigned long __RPC_FAR *, unsigned long            , HICON __RPC_FAR * );
unsigned char __RPC_FAR * __RPC_USER  HICON_UserMarshal(  unsigned long __RPC_FAR *, unsigned char __RPC_FAR *, HICON __RPC_FAR * );
unsigned char __RPC_FAR * __RPC_USER  HICON_UserUnmarshal(unsigned long __RPC_FAR *, unsigned char __RPC_FAR *, HICON __RPC_FAR * );
void                      __RPC_USER  HICON_UserFree(     unsigned long __RPC_FAR *, HICON __RPC_FAR * );

unsigned long             __RPC_USER  HWND_UserSize(     unsigned long __RPC_FAR *, unsigned long            , HWND __RPC_FAR * );
unsigned char __RPC_FAR * __RPC_USER  HWND_UserMarshal(  unsigned long __RPC_FAR *, unsigned char __RPC_FAR *, HWND __RPC_FAR * );
unsigned char __RPC_FAR * __RPC_USER  HWND_UserUnmarshal(unsigned long __RPC_FAR *, unsigned char __RPC_FAR *, HWND __RPC_FAR * );
void                      __RPC_USER  HWND_UserFree(     unsigned long __RPC_FAR *, HWND __RPC_FAR * );

/* end of Additional Prototypes */
*)

function IS_SPECIAL_DATAOBJECT (const d) : BOOL;
function IS_SPECIAL_COOKIE (const c) : BOOL;

implementation

function IS_SPECIAL_DATAOBJECT (const d) : BOOL;
begin
  result := (Integer (d) >= -10) and (Integer (d) <= 0)
end;

function IS_SPECIAL_COOKIE (const c) : BOOL;
begin
  result := (Integer (c) >= -10) and (Integer (c) <= -1)
end;


end.
